
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

static struct static_route *this_srt;



/* Line 189 of yacc.c  */
#line 236 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     GEQ = 261,
     LEQ = 262,
     NEQ = 263,
     AND = 264,
     OR = 265,
     PO = 266,
     PC = 267,
     NUM = 268,
     ENUM = 269,
     RTRID = 270,
     IPA = 271,
     SYM = 272,
     TEXT = 273,
     PREFIX_DUMMY = 274,
     DEFINE = 275,
     ON = 276,
     OFF = 277,
     YES = 278,
     NO = 279,
     LOG = 280,
     SYSLOG = 281,
     ALL = 282,
     DEBUG = 283,
     TRACE = 284,
     INFO = 285,
     REMOTE = 286,
     WARNING = 287,
     ERROR = 288,
     AUTH = 289,
     FATAL = 290,
     BUG = 291,
     STDERR = 292,
     SOFT = 293,
     TIMEFORMAT = 294,
     ISO = 295,
     SHORT = 296,
     LONG = 297,
     BASE = 298,
     NAME = 299,
     CONFIGURE = 300,
     DOWN = 301,
     KERNEL = 302,
     PERSIST = 303,
     SCAN = 304,
     TIME = 305,
     LEARN = 306,
     DEVICE = 307,
     ROUTES = 308,
     ASYNC = 309,
     TABLE = 310,
     ROUTER = 311,
     ID = 312,
     PROTOCOL = 313,
     PREFERENCE = 314,
     DISABLED = 315,
     DIRECT = 316,
     INTERFACE = 317,
     IMPORT = 318,
     EXPORT = 319,
     FILTER = 320,
     NONE = 321,
     STATES = 322,
     FILTERS = 323,
     PASSWORD = 324,
     FROM = 325,
     PASSIVE = 326,
     TO = 327,
     EVENTS = 328,
     PACKETS = 329,
     PROTOCOLS = 330,
     INTERFACES = 331,
     PRIMARY = 332,
     STATS = 333,
     COUNT = 334,
     FOR = 335,
     COMMANDS = 336,
     PREEXPORT = 337,
     GENERATE = 338,
     LISTEN = 339,
     BGP = 340,
     V6ONLY = 341,
     ADDRESS = 342,
     PORT = 343,
     PASSWORDS = 344,
     DESCRIPTION = 345,
     RELOAD = 346,
     IN = 347,
     OUT = 348,
     MRTDUMP = 349,
     MESSAGES = 350,
     RESTRICT = 351,
     SHOW = 352,
     STATUS = 353,
     SUMMARY = 354,
     ROUTE = 355,
     SYMBOLS = 356,
     DUMP = 357,
     RESOURCES = 358,
     SOCKETS = 359,
     NEIGHBORS = 360,
     ATTRIBUTES = 361,
     ECHO = 362,
     DISABLE = 363,
     ENABLE = 364,
     RESTART = 365,
     FUNCTION = 366,
     PRINT = 367,
     PRINTN = 368,
     UNSET = 369,
     RETURN = 370,
     ACCEPT = 371,
     REJECT = 372,
     QUITBIRD = 373,
     INT = 374,
     BOOL = 375,
     IP = 376,
     PREFIX = 377,
     PAIR = 378,
     QUAD = 379,
     SET = 380,
     STRING = 381,
     BGPMASK = 382,
     BGPPATH = 383,
     CLIST = 384,
     IF = 385,
     THEN = 386,
     ELSE = 387,
     CASE = 388,
     TRUE = 389,
     FALSE = 390,
     GW = 391,
     NET = 392,
     MASK = 393,
     PROTO = 394,
     SOURCE = 395,
     SCOPE = 396,
     CAST = 397,
     DEST = 398,
     LEN = 399,
     DEFINED = 400,
     ADD = 401,
     DELETE = 402,
     CONTAINS = 403,
     RESET = 404,
     PREPEND = 405,
     FIRST = 406,
     LAST = 407,
     MATCH = 408,
     EMPTY = 409,
     WHERE = 410,
     EVAL = 411,
     LOCAL = 412,
     NEIGHBOR = 413,
     AS = 414,
     HOLD = 415,
     CONNECT = 416,
     RETRY = 417,
     KEEPALIVE = 418,
     MULTIHOP = 419,
     STARTUP = 420,
     VIA = 421,
     NEXT = 422,
     HOP = 423,
     SELF = 424,
     DEFAULT = 425,
     PATH = 426,
     METRIC = 427,
     START = 428,
     DELAY = 429,
     FORGET = 430,
     WAIT = 431,
     AFTER = 432,
     BGP_PATH = 433,
     BGP_LOCAL_PREF = 434,
     BGP_MED = 435,
     BGP_ORIGIN = 436,
     BGP_NEXT_HOP = 437,
     BGP_ATOMIC_AGGR = 438,
     BGP_AGGREGATOR = 439,
     BGP_COMMUNITY = 440,
     RR = 441,
     RS = 442,
     CLIENT = 443,
     CLUSTER = 444,
     AS4 = 445,
     ADVERTISE = 446,
     IPV4 = 447,
     CAPABILITIES = 448,
     LIMIT = 449,
     PREFER = 450,
     OLDER = 451,
     MISSING = 452,
     LLADDR = 453,
     DROP = 454,
     IGNORE = 455,
     REFRESH = 456,
     INTERPRET = 457,
     COMMUNITIES = 458,
     BGP_ORIGINATOR_ID = 459,
     BGP_CLUSTER_LIST = 460,
     OSPF = 461,
     AREA = 462,
     OSPF_METRIC1 = 463,
     OSPF_METRIC2 = 464,
     OSPF_TAG = 465,
     OSPF_ROUTER_ID = 466,
     BROADCAST = 467,
     RFC1583COMPAT = 468,
     STUB = 469,
     TICK = 470,
     COST = 471,
     RETRANSMIT = 472,
     HELLO = 473,
     TRANSMIT = 474,
     PRIORITY = 475,
     DEAD = 476,
     NONBROADCAST = 477,
     POINTOPOINT = 478,
     TYPE = 479,
     SIMPLE = 480,
     AUTHENTICATION = 481,
     STRICT = 482,
     CRYPTOGRAPHIC = 483,
     ELIGIBLE = 484,
     POLL = 485,
     NETWORKS = 486,
     HIDDEN = 487,
     VIRTUAL = 488,
     LINK = 489,
     RX = 490,
     BUFFER = 491,
     LARGE = 492,
     NORMAL = 493,
     STUBNET = 494,
     LSADB = 495,
     TOPOLOGY = 496,
     STATE = 497,
     PIPE = 498,
     PEER = 499,
     MODE = 500,
     OPAQUE = 501,
     TRANSPARENT = 502,
     RIP = 503,
     INFINITY = 504,
     PERIOD = 505,
     GARBAGE = 506,
     TIMEOUT = 507,
     MULTICAST = 508,
     QUIET = 509,
     NOLISTEN = 510,
     VERSION1 = 511,
     PLAINTEXT = 512,
     MD5 = 513,
     HONOR = 514,
     NEVER = 515,
     ALWAYS = 516,
     RIP_METRIC = 517,
     RIP_TAG = 518,
     STATIC = 519,
     PROHIBIT = 520
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 157 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 214 of yacc.c  */
#line 561 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 573 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  51
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1733

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  287
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  196
/* YYNRULES -- Number of rules.  */
#define YYNRULES  600
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1112

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   520

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     277,   278,    27,    25,   283,    26,    24,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   280,   279,
      21,    20,    22,   284,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   285,     2,   286,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   281,     2,   282,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    74,
      75,    77,    80,    82,    84,    88,    90,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   117,   121,   123,
     125,   127,   129,   132,   137,   141,   145,   149,   153,   158,
     161,   162,   164,   167,   170,   174,   177,   181,   184,   188,
     192,   196,   201,   203,   205,   207,   212,   213,   216,   219,
     222,   224,   227,   229,   230,   232,   233,   236,   239,   242,
     245,   248,   251,   254,   258,   261,   264,   266,   268,   270,
     272,   276,   280,   281,   283,   285,   288,   289,   291,   295,
     297,   301,   304,   308,   312,   316,   317,   321,   323,   325,
     329,   331,   335,   337,   339,   341,   343,   345,   347,   349,
     351,   355,   357,   361,   363,   365,   370,   372,   373,   377,
     382,   384,   387,   388,   394,   400,   406,   412,   417,   421,
     426,   432,   434,   435,   439,   444,   449,   450,   453,   457,
     461,   465,   468,   471,   474,   478,   482,   485,   488,   490,
     492,   497,   501,   505,   509,   513,   517,   521,   525,   530,
     532,   534,   536,   537,   539,   543,   547,   551,   555,   560,
     565,   570,   575,   578,   580,   582,   584,   586,   587,   589,
     590,   595,   598,   600,   602,   604,   606,   608,   610,   612,
     614,   616,   618,   621,   624,   625,   629,   631,   635,   637,
     639,   641,   644,   648,   651,   656,   657,   663,   664,   666,
     668,   671,   673,   677,   683,   685,   687,   689,   691,   693,
     695,   697,   702,   704,   708,   712,   714,   717,   720,   727,
     729,   733,   734,   739,   744,   746,   750,   754,   758,   761,
     764,   767,   770,   771,   774,   777,   778,   784,   786,   788,
     790,   792,   794,   796,   798,   802,   806,   808,   810,   811,
     816,   818,   820,   822,   824,   826,   828,   830,   832,   834,
     838,   842,   846,   850,   854,   858,   862,   866,   870,   874,
     878,   882,   886,   890,   893,   898,   900,   902,   904,   906,
     909,   912,   916,   920,   927,   931,   935,   939,   943,   950,
     957,   964,   969,   971,   973,   975,   977,   979,   981,   983,
     984,   986,   990,   992,   996,   997,   999,  1004,  1011,  1016,
    1020,  1026,  1032,  1037,  1044,  1048,  1051,  1057,  1063,  1072,
    1081,  1090,  1093,  1097,  1101,  1107,  1114,  1121,  1126,  1131,
    1137,  1144,  1151,  1157,  1164,  1170,  1176,  1182,  1188,  1194,
    1200,  1206,  1212,  1218,  1225,  1232,  1241,  1248,  1255,  1261,
    1266,  1272,  1277,  1283,  1288,  1294,  1297,  1301,  1305,  1307,
    1310,  1313,  1316,  1320,  1323,  1324,  1328,  1332,  1335,  1340,
    1343,  1346,  1348,  1353,  1355,  1357,  1358,  1362,  1365,  1368,
    1371,  1376,  1378,  1379,  1383,  1384,  1387,  1390,  1394,  1397,
    1400,  1404,  1407,  1410,  1413,  1415,  1419,  1422,  1425,  1428,
    1431,  1435,  1438,  1441,  1444,  1448,  1451,  1454,  1457,  1461,
    1464,  1469,  1472,  1475,  1478,  1482,  1486,  1490,  1492,  1493,
    1496,  1498,  1500,  1503,  1507,  1508,  1511,  1513,  1515,  1518,
    1522,  1523,  1524,  1528,  1529,  1533,  1537,  1539,  1540,  1545,
    1552,  1559,  1566,  1573,  1580,  1583,  1587,  1591,  1597,  1602,
    1607,  1610,  1614,  1618,  1623,  1628,  1633,  1639,  1645,  1650,
    1654,  1659,  1664,  1669,  1674,  1676,  1678,  1680,  1682,  1684,
    1686,  1688,  1690,  1691,  1694,  1697,  1698,  1702,  1703,  1707,
    1708,  1712,  1715,  1719,  1723,  1727,  1730,  1734,  1738,  1741,
    1744,  1747,  1752,  1754,  1756,  1758,  1760,  1762,  1764,  1766,
    1768,  1770,  1772,  1774,  1776,  1778,  1780,  1782,  1784,  1786,
    1788,  1790,  1792,  1794,  1796,  1798,  1800,  1802,  1804,  1806,
    1808,  1810,  1812,  1814,  1816,  1818,  1820,  1822,  1824,  1826,
    1828,  1830,  1832,  1834,  1836,  1838,  1840,  1842,  1844,  1846,
    1849,  1852,  1855,  1858,  1861,  1864,  1867,  1870,  1874,  1878,
    1882,  1886,  1890,  1894,  1898,  1900,  1902,  1904,  1906,  1908,
    1910,  1912,  1914,  1916,  1918,  1920,  1922,  1924,  1926,  1928,
    1930
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     288,     0,    -1,   289,     3,    -1,     4,   478,    -1,    -1,
     289,   477,    -1,    13,    -1,   277,   417,   278,    -1,    17,
      -1,    31,    17,    20,   290,   279,    -1,    31,    17,    20,
      16,   279,    -1,   290,    -1,    32,    -1,    34,    -1,    33,
      -1,    35,    -1,    -1,    16,    -1,    17,    -1,   293,   296,
      -1,   294,    -1,   293,    -1,    28,   290,    -1,   280,   293,
      -1,    18,    -1,    18,    -1,    -1,    36,   301,   302,   279,
      -1,    55,    18,    -1,    -1,    18,    -1,    37,   300,    -1,
      48,    -1,    38,    -1,   281,   303,   282,    -1,   304,    -1,
     303,   283,   304,    -1,    39,    -1,    40,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,   105,    86,   342,   279,    -1,   105,    18,   279,
      -1,   111,    -1,    69,    -1,    54,    -1,    36,    -1,   306,
      18,    -1,   306,    18,   290,    18,    -1,   306,    51,    52,
      -1,   306,    51,    53,    -1,    50,   307,   279,    -1,    56,
     312,     3,    -1,    56,    49,   312,     3,    -1,    57,     3,
      -1,    -1,    18,    -1,   324,    58,    -1,    59,   292,    -1,
      60,    61,   290,    -1,    62,   292,    -1,    63,    64,   292,
      -1,   324,    63,    -1,    60,    61,   290,    -1,    88,   298,
     295,    -1,    58,    66,   290,    -1,    67,    68,   319,   279,
      -1,    13,    -1,    15,    -1,    16,    -1,    95,    96,   321,
     279,    -1,    -1,   321,   322,    -1,    98,   293,    -1,    99,
     290,    -1,    97,    -1,    66,    17,    -1,    69,    -1,    -1,
      17,    -1,    -1,    70,   290,    -1,    71,   292,    -1,    39,
     339,    -1,   105,   342,    -1,    74,   327,    -1,    75,   327,
      -1,    66,   328,    -1,    67,    68,   319,    -1,   101,    18,
      -1,    76,   389,    -1,   390,    -1,    38,    -1,    77,    -1,
      17,    -1,    39,    86,   339,    -1,    39,    92,   290,    -1,
      -1,    18,    -1,   295,    -1,    18,   295,    -1,    -1,    26,
      -1,   330,   332,   331,    -1,   333,    -1,   334,   283,   333,
      -1,   324,    72,    -1,   335,   325,   281,    -1,   336,   326,
     279,    -1,   336,   338,   279,    -1,    -1,    73,   337,   334,
      -1,    38,    -1,    33,    -1,   281,   340,   282,    -1,   341,
      -1,   340,   283,   341,    -1,    78,    -1,    64,    -1,    79,
      -1,    87,    -1,    84,    -1,    85,    -1,    38,    -1,    33,
      -1,   281,   343,   282,    -1,   344,    -1,   343,   283,   344,
      -1,    78,    -1,   106,    -1,   100,   281,   346,   282,    -1,
     347,    -1,    -1,   347,   279,   346,    -1,   348,   281,   349,
     282,    -1,   348,    -1,    80,    18,    -1,    -1,    94,    81,
     297,   279,   349,    -1,    94,    83,   297,   279,   349,    -1,
     127,    81,   297,   279,   349,    -1,   127,    83,   297,   279,
     349,    -1,    68,   290,   279,   349,    -1,   108,   109,     3,
      -1,   108,    86,   380,     3,    -1,   108,    86,    38,   380,
       3,    -1,    17,    -1,    -1,   108,    87,     3,    -1,   108,
      87,   110,     3,    -1,   108,   111,   357,     3,    -1,    -1,
     357,   294,    -1,   357,    91,   295,    -1,   357,    66,    17,
      -1,   357,    76,   389,    -1,   357,   390,    -1,   357,    38,
      -1,   357,    88,    -1,   357,   358,    17,    -1,   357,    69,
      17,    -1,   357,    89,    -1,   357,    90,    -1,    93,    -1,
      75,    -1,   108,   112,   353,     3,    -1,   113,   114,     3,
      -1,   113,   115,     3,    -1,   113,    87,     3,    -1,   113,
     116,     3,    -1,   113,   117,     3,    -1,   113,    64,     3,
      -1,   113,    86,     3,    -1,   118,   368,   369,     3,    -1,
      38,    -1,    33,    -1,    13,    -1,    -1,    13,    -1,   119,
     379,     3,    -1,   120,   379,     3,    -1,   121,   379,     3,
      -1,   102,   379,     3,    -1,   102,   103,   379,     3,    -1,
     102,   104,   379,     3,    -1,    39,   379,   339,     3,    -1,
     105,   379,   342,     3,    -1,   107,     3,    -1,    17,    -1,
      38,    -1,    18,    -1,    17,    -1,    -1,    18,    -1,    -1,
      76,    17,   382,   388,    -1,   167,   417,    -1,   130,    -1,
     131,    -1,   132,    -1,   133,    -1,   134,    -1,   135,    -1,
     137,    -1,   138,    -1,   139,    -1,   140,    -1,   384,   136,
      -1,   384,    17,    -1,    -1,   385,   279,   386,    -1,   385,
      -1,   387,   279,   385,    -1,   392,    -1,    17,    -1,   388,
      -1,   166,   417,    -1,   277,   387,   278,    -1,   277,   278,
      -1,   386,   281,   395,   282,    -1,    -1,   122,    17,   394,
     391,   392,    -1,    -1,   396,    -1,   423,    -1,   396,   423,
      -1,   423,    -1,   281,   395,   282,    -1,   277,    13,   283,
      13,   278,    -1,    16,    -1,    13,    -1,    15,    -1,   398,
      -1,   399,    -1,    14,    -1,   400,    -1,   400,    24,    24,
     400,    -1,   401,    -1,   402,   283,   401,    -1,    16,    28,
      13,    -1,   403,    -1,   403,    25,    -1,   403,    26,    -1,
     403,   281,    13,   283,    13,   282,    -1,   404,    -1,   405,
     283,   404,    -1,    -1,   406,   401,   280,   395,    -1,   406,
     143,   280,   395,    -1,   415,    -1,   277,   417,   278,    -1,
      11,   409,    12,    -1,    28,   410,    28,    -1,    13,   409,
      -1,    27,   409,    -1,   284,   409,    -1,   407,   409,    -1,
      -1,    13,   410,    -1,   284,   410,    -1,    -1,   277,   417,
     283,   417,   278,    -1,    13,    -1,   145,    -1,   146,    -1,
      18,    -1,   399,    -1,   403,    -1,    15,    -1,   285,   402,
     286,    -1,   285,   405,   286,    -1,    14,    -1,   408,    -1,
      -1,    17,   277,   422,   278,    -1,    17,    -1,    81,    -1,
     147,    -1,   148,    -1,   150,    -1,   151,    -1,   152,    -1,
     153,    -1,   154,    -1,   277,   417,   278,    -1,   417,    25,
     417,    -1,   417,    26,   417,    -1,   417,    27,   417,    -1,
     417,    28,   417,    -1,   417,     9,   417,    -1,   417,    10,
     417,    -1,   417,    20,   417,    -1,   417,     8,   417,    -1,
     417,    21,   417,    -1,   417,     7,   417,    -1,   417,    22,
     417,    -1,   417,     6,   417,    -1,   417,    23,   417,    -1,
      30,   417,    -1,   156,   277,   417,   278,    -1,   415,    -1,
     412,    -1,   411,    -1,    70,    -1,   413,   416,    -1,   413,
     482,    -1,   417,    24,   132,    -1,   417,    24,   155,    -1,
     417,    24,   149,   277,   417,   278,    -1,   417,    24,   162,
      -1,   417,    24,   163,    -1,    25,   165,    25,    -1,    26,
     165,    26,    -1,   161,   277,   417,   283,   417,   278,    -1,
     157,   277,   417,   283,   417,   278,    -1,   158,   277,   417,
     283,   417,   278,    -1,    17,   277,   422,   278,    -1,   129,
      -1,   127,    -1,   128,    -1,    44,    -1,   123,    -1,   124,
      -1,   417,    -1,    -1,   419,    -1,   419,   283,   420,    -1,
     417,    -1,   417,   283,   421,    -1,    -1,   421,    -1,   141,
     417,   142,   397,    -1,   141,   417,   142,   397,   143,   397,
      -1,    17,    20,   417,   279,    -1,   126,   417,   279,    -1,
     413,   482,    20,   417,   279,    -1,   413,   416,    20,   417,
     279,    -1,    70,    20,   417,   279,    -1,   125,   277,   413,
     482,   278,   279,    -1,   418,   420,   279,    -1,   414,   279,
      -1,   144,   417,   281,   406,   282,    -1,   413,   482,    24,
     165,   279,    -1,   413,   482,    24,   161,   277,   417,   278,
     279,    -1,   413,   482,    24,   157,   277,   417,   278,   279,
      -1,   413,   482,    24,   158,   277,   417,   278,   279,    -1,
     324,    96,    -1,   424,   325,   281,    -1,   425,   326,   279,
      -1,   425,   168,   170,   290,   279,    -1,   425,   169,   293,
     170,   290,   279,    -1,   425,   197,   200,    68,   319,   279,
      -1,   425,   197,   199,   279,    -1,   425,   198,   199,   279,
      -1,   425,   171,    61,   290,   279,    -1,   425,   176,   171,
      61,   290,   279,    -1,   425,   172,   173,    61,   290,   279,
      -1,   425,   174,    61,   290,   279,    -1,   425,   175,   290,
     177,   293,   279,    -1,   425,   178,   179,   180,   279,    -1,
     425,   208,   209,   180,   279,    -1,   425,   208,   209,   210,
     279,    -1,   425,   208,   209,   211,   279,    -1,   425,   182,
     183,   292,   279,    -1,   425,   206,   207,   292,   279,    -1,
     425,   181,   191,   290,   279,    -1,   425,   181,   190,   290,
     279,    -1,   425,   151,    98,   293,   279,    -1,   425,   184,
     185,    61,   290,   279,    -1,   425,    44,   186,    61,   290,
     279,    -1,   425,    44,   187,    61,   290,   283,   290,   279,
      -1,   425,   119,   188,    44,   292,   279,    -1,   425,   120,
     111,   212,   292,   279,    -1,   425,   120,   201,   292,   279,
      -1,   425,   204,   292,   279,    -1,   425,   202,   203,   292,
     279,    -1,   425,    80,    18,   279,    -1,   425,   111,   205,
     290,   279,    -1,   425,    82,   292,   279,    -1,   425,   213,
     214,   292,   279,    -1,   324,   217,    -1,   426,   325,   281,
      -1,   427,   428,   279,    -1,   326,    -1,   224,   292,    -1,
     226,   290,    -1,   430,   282,    -1,   218,   319,   281,    -1,
     429,   431,    -1,    -1,   431,   432,   279,    -1,   225,   227,
     290,    -1,   225,   292,    -1,   242,   281,   442,   282,    -1,
     250,   433,    -1,    73,   453,    -1,   437,    -1,   434,   281,
     435,   282,    -1,   434,    -1,   294,    -1,    -1,   435,   436,
     279,    -1,   243,   292,    -1,   110,   292,    -1,   227,   290,
      -1,   440,   281,   438,   282,    -1,   440,    -1,    -1,   438,
     439,   279,    -1,    -1,   229,   290,    -1,   228,   290,    -1,
     230,   185,   290,    -1,   187,   290,    -1,   232,   290,    -1,
     232,    90,   290,    -1,   237,    77,    -1,   237,   236,    -1,
     237,   239,    -1,   345,    -1,   244,   245,   319,    -1,   227,
     290,    -1,   229,   290,    -1,   241,   290,    -1,   228,   290,
      -1,   230,   185,   290,    -1,   231,   290,    -1,   187,   290,
      -1,   232,   290,    -1,   232,    90,   290,    -1,   235,   223,
      -1,   235,   233,    -1,   235,   234,    -1,   238,   233,   292,
      -1,   225,   292,    -1,   116,   281,   446,   282,    -1,   237,
      77,    -1,   237,   236,    -1,   237,   239,    -1,   246,   247,
     248,    -1,   246,   247,   249,    -1,   246,   247,   290,    -1,
     345,    -1,    -1,   442,   443,    -1,   444,    -1,   445,    -1,
     294,   279,    -1,   294,   243,   279,    -1,    -1,   446,   447,
      -1,   448,    -1,   449,    -1,    16,   279,    -1,    16,   240,
     279,    -1,    -1,    -1,   451,   441,   279,    -1,    -1,   281,
     451,   282,    -1,   450,   334,   452,    -1,    18,    -1,    -1,
     108,   217,   353,     3,    -1,   108,   217,   116,   353,   454,
       3,    -1,   108,   217,    73,   353,   454,     3,    -1,   108,
     217,   252,   353,   454,     3,    -1,   108,   217,   253,   353,
     454,     3,    -1,   108,   217,   251,   353,   454,     3,    -1,
     324,   254,    -1,   461,   325,   281,    -1,   462,   326,   279,
      -1,   462,   255,    66,    17,   279,    -1,   462,   256,   257,
     279,    -1,   462,   256,   258,   279,    -1,   324,   259,    -1,
     463,   325,   281,    -1,   464,   326,   279,    -1,   464,   260,
     290,   279,    -1,   464,    99,   290,   279,    -1,   464,   261,
     290,   279,    -1,   464,   262,    61,   290,   279,    -1,   464,
     263,    61,   290,   279,    -1,   464,   237,   465,   279,    -1,
     464,   345,   279,    -1,   464,   270,   272,   279,    -1,   464,
     270,   169,   279,    -1,   464,   270,   271,   279,    -1,   464,
      73,   471,   279,    -1,   268,    -1,   269,    -1,    77,    -1,
     223,    -1,   264,    -1,   265,    -1,   266,    -1,   267,    -1,
      -1,   183,   290,    -1,   256,   466,    -1,    -1,   468,   467,
     279,    -1,    -1,   281,   468,   282,    -1,    -1,   470,   334,
     469,    -1,   324,   275,    -1,   472,   325,   281,    -1,   473,
     326,   279,    -1,   473,   475,   279,    -1,   111,   294,    -1,
     474,   177,   293,    -1,   474,   177,    18,    -1,   474,   210,
      -1,   474,   128,    -1,   474,   276,    -1,   108,   275,   353,
       3,    -1,   279,    -1,   291,    -1,   299,    -1,   305,    -1,
     308,    -1,   318,    -1,   320,    -1,   323,    -1,   479,    -1,
     329,    -1,   381,    -1,   383,    -1,   393,    -1,   309,    -1,
     310,    -1,   311,    -1,   350,    -1,   351,    -1,   352,    -1,
     354,    -1,   355,    -1,   356,    -1,   359,    -1,   360,    -1,
     361,    -1,   362,    -1,   363,    -1,   364,    -1,   365,    -1,
     366,    -1,   367,    -1,   370,    -1,   371,    -1,   372,    -1,
     373,    -1,   374,    -1,   375,    -1,   376,    -1,   377,    -1,
     378,    -1,   455,    -1,   456,    -1,   457,    -1,   458,    -1,
     459,    -1,   460,    -1,   476,    -1,   480,   282,    -1,   481,
     282,    -1,   336,   282,    -1,   425,   282,    -1,   427,   282,
      -1,   462,   282,    -1,   464,   282,    -1,   473,   282,    -1,
     313,   325,   281,    -1,   480,   326,   279,    -1,   480,   314,
     279,    -1,   480,   317,   279,    -1,   315,   325,   281,    -1,
     481,   326,   279,    -1,   481,   316,   279,    -1,     5,    -1,
     192,    -1,   189,    -1,   193,    -1,   191,    -1,   190,    -1,
     194,    -1,   195,    -1,   196,    -1,   215,    -1,   216,    -1,
     219,    -1,   220,    -1,   221,    -1,   222,    -1,   273,    -1,
     274,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   312,   312,   313,   316,   318,   325,   326,   327,   331,
     335,   344,   345,   346,   347,   348,   349,   355,   356,   363,
     370,   371,   375,   379,   386,   394,   395,   401,   410,   411,
     415,   420,   421,   425,   426,   430,   431,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   449,   450,   459,   460,
     461,   462,   465,   466,   467,   468,   472,   479,   482,   485,
     489,   490,   498,   514,   515,   519,   526,   532,   545,   549,
     562,   574,   580,   581,   582,   593,   595,   597,   601,   602,
     603,   610,   618,   622,   628,   634,   636,   640,   641,   642,
     643,   644,   645,   646,   647,   651,   652,   653,   654,   658,
     666,   667,   675,   683,   684,   685,   689,   690,   694,   699,
     700,   707,   716,   717,   718,   722,   731,   737,   738,   739,
     743,   744,   748,   749,   750,   751,   752,   753,   759,   760,
     761,   765,   766,   770,   771,   777,   778,   781,   783,   787,
     788,   792,   810,   811,   812,   813,   814,   815,   823,   826,
     829,   833,   834,   837,   840,   843,   847,   853,   859,   866,
     871,   876,   881,   885,   889,   899,   907,   911,   918,   919,
     922,   926,   928,   930,   932,   934,   936,   938,   941,   947,
     948,   949,   953,   954,   960,   962,   964,   966,   968,   970,
     974,   978,   981,   985,   986,   987,   991,   992,   993,  1000,
    1000,  1009,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1043,  1054,  1055,  1062,  1063,  1070,  1079,
    1083,  1087,  1111,  1112,  1116,  1129,  1129,  1145,  1146,  1149,
    1150,  1154,  1157,  1166,  1173,  1177,  1178,  1179,  1180,  1181,
    1185,  1190,  1198,  1199,  1203,  1210,  1211,  1212,  1213,  1220,
    1221,  1224,  1225,  1230,  1242,  1243,  1247,  1248,  1252,  1253,
    1254,  1255,  1256,  1260,  1261,  1262,  1266,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,  1286,  1287,  1288,  1289,  1299,  1303,
    1326,  1360,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1372,
    1373,  1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,  1387,  1389,  1390,  1391,  1393,  1395,
    1397,  1399,  1400,  1401,  1402,  1403,  1413,  1414,  1415,  1416,
    1417,  1422,  1445,  1446,  1447,  1448,  1449,  1450,  1454,  1457,
    1458,  1459,  1468,  1475,  1484,  1485,  1489,  1495,  1505,  1514,
    1520,  1525,  1532,  1537,  1543,  1544,  1545,  1553,  1555,  1556,
    1557,  1563,  1584,  1585,  1586,  1587,  1593,  1594,  1595,  1596,
    1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,
    1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,
    1617,  1618,  1619,  1620,  1621,  1631,  1641,  1642,  1646,  1647,
    1648,  1649,  1652,  1664,  1667,  1669,  1673,  1674,  1675,  1676,
    1677,  1678,  1682,  1683,  1687,  1695,  1697,  1701,  1702,  1703,
    1707,  1708,  1711,  1713,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1729,  1751,  1752,  1753,  1754,
    1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,
    1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1775,  1777,
    1781,  1782,  1784,  1793,  1803,  1805,  1809,  1810,  1812,  1821,
    1832,  1854,  1856,  1859,  1861,  1865,  1869,  1870,  1874,  1877,
    1880,  1883,  1886,  1889,  1895,  1903,  1904,  1905,  1910,  1911,
    1917,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,
    1933,  1934,  1935,  1936,  1940,  1941,  1942,  1947,  1948,  1949,
    1950,  1951,  1954,  1955,  1956,  1959,  1961,  1964,  1966,  1970,
    1979,  1986,  1993,  1994,  1995,  1998,  2007,  2011,  2017,  2018,
    2019,  2022,  2029,  2029,  2029,  2029,  2029,  2029,  2029,  2029,
    2029,  2029,  2029,  2029,  2029,  2030,  2030,  2030,  2030,  2030,
    2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,
    2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,
    2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2030,  2031,
    2031,  2031,  2031,  2031,  2031,  2031,  2031,  2032,  2032,  2032,
    2032,  2033,  2033,  2033,  2034,  2034,  2035,  2036,  2037,  2038,
    2039,  2040,  2041,  2042,  2043,  2044,  2044,  2044,  2044,  2044,
    2044
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "RTRID",
  "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "'.'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "DEFINE", "ON", "OFF", "YES",
  "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE",
  "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE", "DISABLED",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES",
  "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP", "V6ONLY",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN", "OUT",
  "MRTDUMP", "MESSAGES", "RESTRICT", "SHOW", "STATUS", "SUMMARY", "ROUTE",
  "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES",
  "ECHO", "DISABLE", "ENABLE", "RESTART", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST",
  "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "GW", "NET", "MASK",
  "PROTO", "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED", "ADD",
  "DELETE", "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH",
  "EMPTY", "WHERE", "EVAL", "LOCAL", "NEIGHBOR", "AS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "MULTIHOP", "STARTUP", "VIA", "NEXT", "HOP",
  "SELF", "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "WAIT",
  "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN",
  "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4",
  "CAPABILITIES", "LIMIT", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "BROADCAST", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "NONBROADCAST", "POINTOPOINT", "TYPE", "SIMPLE", "AUTHENTICATION",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET", "LSADB",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "'('", "')'", "';'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args",
  "export_or_preexport", "cmd_SHOW_SYMBOLS", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE",
  "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT",
  "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "cpair", "fipa", "set_atom", "set_item", "set_items", "fprefix_s",
  "fprefix", "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_LSADB",
  "pipe_proto_start", "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth",
  "rip_mode", "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      61,    60,    62,   126,    46,    43,    45,    42,    47,    37,
      33,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,    40,    41,    59,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   287,   288,   288,   289,   289,   290,   290,   290,   291,
     291,   292,   292,   292,   292,   292,   292,   293,   293,   294,
     295,   295,   296,   296,   297,   298,   298,   299,   300,   300,
     301,   301,   301,   302,   302,   303,   303,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   305,   305,   306,   306,
     306,   306,   307,   307,   307,   307,   308,   309,   310,   311,
     312,   312,   313,   314,   314,   314,   314,   315,   316,   316,
     317,   318,   319,   319,   319,   320,   321,   321,   322,   322,
     322,   323,   324,   325,   325,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   327,   327,   327,   327,   328,
     329,   329,   330,   331,   331,   331,   332,   332,   333,   334,
     334,   335,   336,   336,   336,   337,   338,   339,   339,   339,
     340,   340,   341,   341,   341,   341,   341,   341,   342,   342,
     342,   343,   343,   344,   344,   345,   345,   346,   346,   347,
     347,   348,   349,   349,   349,   349,   349,   349,   350,   351,
     352,   353,   353,   354,   355,   356,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   358,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     368,   368,   369,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   379,   379,   380,   380,   380,   382,
     381,   383,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   385,   386,   386,   387,   387,   388,   389,
     389,   390,   391,   391,   392,   394,   393,   395,   395,   396,
     396,   397,   397,   398,   399,   400,   400,   400,   400,   400,
     401,   401,   402,   402,   403,   404,   404,   404,   404,   405,
     405,   406,   406,   406,   407,   407,   408,   408,   409,   409,
     409,   409,   409,   410,   410,   410,   411,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   413,   414,
     415,   416,   416,   416,   416,   416,   416,   416,   416,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   418,   418,   418,   418,   418,   418,   419,   420,
     420,   420,   421,   421,   422,   422,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   424,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   426,   427,   427,   428,   428,
     428,   428,   429,   430,   431,   431,   432,   432,   432,   432,
     432,   432,   433,   433,   434,   435,   435,   436,   436,   436,
     437,   437,   438,   438,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   440,   441,   441,   441,   441,
     441,   441,   441,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   441,   441,   441,   441,   441,   442,   442,
     443,   443,   444,   445,   446,   446,   447,   447,   448,   449,
     450,   451,   451,   452,   452,   453,   454,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   462,   462,   462,   462,
     463,   464,   464,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   465,   465,   465,   466,   466,   466,
     466,   466,   467,   467,   467,   468,   468,   469,   469,   470,
     471,   472,   473,   473,   473,   474,   475,   475,   475,   475,
     475,   476,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   479,
     479,   479,   479,   479,   479,   479,   479,   480,   480,   480,
     480,   481,   481,   481,   482,   482,   482,   482,   482,   482,
     482,   482,   482,   482,   482,   482,   482,   482,   482,   482,
     482
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     2,     0,
       1,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     4,     3,     3,     3,     3,     4,     2,
       0,     1,     2,     2,     3,     2,     3,     2,     3,     3,
       3,     4,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     2,     1,     0,     1,     0,     2,     2,     2,     2,
       2,     2,     2,     3,     2,     2,     1,     1,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     2,     3,     3,     3,     0,     3,     1,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     1,     1,     4,     1,     0,     3,     4,
       1,     2,     0,     5,     5,     5,     5,     4,     3,     4,
       5,     1,     0,     3,     4,     4,     0,     2,     3,     3,
       3,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       4,     3,     3,     3,     3,     3,     3,     3,     4,     1,
       1,     1,     0,     1,     3,     3,     3,     3,     4,     4,
       4,     4,     2,     1,     1,     1,     1,     0,     1,     0,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     0,     3,     1,     3,     1,     1,
       1,     2,     3,     2,     4,     0,     5,     0,     1,     1,
       2,     1,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     3,     3,     1,     2,     2,     6,     1,
       3,     0,     4,     4,     1,     3,     3,     3,     2,     2,
       2,     2,     0,     2,     2,     0,     5,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     4,     1,     1,     1,     1,     2,
       2,     3,     3,     6,     3,     3,     3,     3,     6,     6,
       6,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     3,     1,     3,     0,     1,     4,     6,     4,     3,
       5,     5,     4,     6,     3,     2,     5,     5,     8,     8,
       8,     2,     3,     3,     5,     6,     6,     4,     4,     5,
       6,     6,     5,     6,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     6,     6,     8,     6,     6,     5,     4,
       5,     4,     5,     4,     5,     2,     3,     3,     1,     2,
       2,     2,     3,     2,     0,     3,     3,     2,     4,     2,
       2,     1,     4,     1,     1,     0,     3,     2,     2,     2,
       4,     1,     0,     3,     0,     2,     2,     3,     2,     2,
       3,     2,     2,     2,     1,     3,     2,     2,     2,     2,
       3,     2,     2,     2,     3,     2,     2,     2,     3,     2,
       4,     2,     2,     2,     3,     3,     3,     1,     0,     2,
       1,     1,     2,     3,     0,     2,     1,     1,     2,     3,
       0,     0,     3,     0,     3,     3,     1,     0,     4,     6,
       6,     6,     6,     6,     2,     3,     3,     5,     4,     4,
       2,     3,     3,     4,     4,     4,     5,     5,     4,     3,
       4,     4,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     2,     0,     3,     0,     3,     0,
       3,     2,     3,     3,     3,     2,     3,     3,     2,     2,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
       3,     1,     2,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,   278,   522,   523,   524,   525,   526,
      83,    83,   527,   528,   529,     0,   531,    83,    85,   532,
     533,   534,    83,    85,    83,    85,    83,    85,    83,    85,
      83,    85,     5,   530,    85,    85,   193,   195,   194,     0,
      61,    60,     0,    59,     0,     0,     0,     0,   192,   197,
       0,     0,   156,   152,   152,   152,     0,     0,     0,     0,
       0,     0,     0,   181,   180,   179,   182,     0,     0,     0,
       0,    30,    29,    32,     0,     0,     0,    51,    50,    49,
      48,     0,     0,    81,     0,   199,    76,     0,     0,   225,
     262,   267,   276,   273,   234,   280,   270,     0,     0,   265,
     278,   308,   268,   269,     0,     0,     0,     0,   278,     0,
     271,   272,   277,   307,   306,     0,   305,   201,    84,     0,
       0,    62,    67,   111,   351,   385,   474,   480,   511,     0,
       0,     0,     0,     0,    16,   115,     0,     0,     0,     0,
     571,     0,     0,     0,     0,     0,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,   572,
       0,     0,     0,    16,     0,   573,   388,     0,   394,     0,
       0,     0,     0,   574,     0,     0,   509,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   575,     0,     0,   136,
     140,     0,     0,   576,     0,     0,     0,     0,    16,     0,
      16,     0,   569,     0,     0,     0,     0,    26,   570,     0,
       0,   118,   117,     0,     0,     0,    57,     0,     0,   187,
     129,   128,     0,     0,   196,   198,   197,     0,   153,     0,
     148,     0,   151,     0,   152,   152,   152,   152,   152,     0,
       0,   176,   177,   173,   171,   172,   174,   175,   183,     0,
     184,   185,   186,     0,     0,    31,    33,     0,     0,   100,
       6,     8,   278,   101,    52,     0,    56,    72,    73,    74,
       0,   214,     0,    47,     0,     0,   262,   280,   262,   278,
     262,   262,     0,   254,     0,   278,     0,     0,   265,   265,
       0,   303,   278,   278,   278,   278,     0,   235,   239,   236,
       0,   237,   238,   240,   242,     0,   245,   249,     0,   584,
     281,   282,   283,   284,   285,   286,   287,   288,   586,   589,
     588,   585,   587,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   309,   310,   278,   278,   278,   278,
     278,   278,   278,   278,   278,     0,   278,   278,   278,   278,
     577,   581,   112,    88,    99,    92,     0,    86,    12,    14,
      13,    15,    11,    87,   102,    97,   214,    98,   278,    90,
      96,    91,    94,    89,   113,   114,   352,     0,     0,     0,
       0,     0,     0,     0,    16,     0,     0,    17,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
       0,     0,     0,    16,     0,    16,     0,    16,   353,   386,
       0,   389,   390,   387,   393,   391,   475,     0,     0,     0,
     476,   481,   102,     0,   141,     0,   137,   496,   494,   495,
       0,     0,     0,     0,     0,     0,     0,     0,   482,   489,
     142,   512,     0,   515,   513,   519,     0,   518,   520,   514,
       0,    63,     0,    65,    16,   579,   580,   578,     0,    25,
       0,   583,   582,   123,   122,   124,   126,   127,   125,     0,
     120,   190,    58,   188,   189,   133,   134,     0,   131,   191,
       0,   149,   154,   155,   162,     0,     0,   169,   214,   163,
     166,   167,     0,   168,   157,     0,   161,   170,   467,   467,
     467,   467,   467,   468,   521,   178,     0,     0,    28,    37,
      38,    39,    40,    41,    42,    43,    44,    45,     0,    35,
      27,     0,     0,    54,    55,    71,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,     0,     0,     0,   200,
     218,    80,     0,     0,    75,    77,    46,     0,   214,   258,
     259,     0,   260,   261,   256,   244,   332,   335,     0,   316,
     317,   263,   264,   257,     0,     0,     0,     0,   289,   278,
       0,     0,     0,   274,   246,   247,     0,     0,   275,   301,
     299,   297,   294,   295,   296,   298,   300,   302,   311,     0,
     312,   314,   315,   290,   291,   292,   293,    93,   106,   109,
     116,   219,   220,    95,   221,     0,     0,   381,   383,     0,
      16,    16,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   357,     0,   358,     0,
     379,     0,     0,     0,     0,     0,   392,   460,    16,     0,
       0,     0,     0,   401,   411,     0,   478,   479,   507,   493,
     484,     0,     0,   488,   483,   485,     0,     0,   491,   492,
     490,     0,     0,     0,     0,     0,     0,    19,   517,   516,
      70,    64,    66,    68,    21,    20,    69,   119,     0,   130,
       0,   150,   159,   165,   160,   158,   164,   466,     0,     0,
       0,     0,     0,    10,     9,    34,     0,     7,    53,   213,
     212,   214,   278,    78,    79,   223,   216,     0,   226,   255,
     278,   321,   304,   278,   278,   278,     0,     0,     0,   234,
     243,     0,     0,   250,   278,   107,     0,   102,     0,     0,
     382,     0,     0,   378,   372,   354,     0,   359,     0,   362,
       0,     0,   364,   371,   370,   368,     0,     0,   380,   369,
     365,   366,   367,   384,   102,   400,     0,   397,   448,     0,
     404,   399,   403,   395,   412,   477,   505,   510,   135,   137,
     486,   487,     0,     0,     0,     0,     0,   139,    22,    23,
     121,   132,   470,   469,   473,   471,   472,    36,   215,     0,
     325,     0,   326,   327,     0,   278,   323,   324,   322,   278,
     278,     0,   278,     0,     0,   278,   229,   222,     0,   333,
       0,     0,     0,   266,     0,   241,     0,     0,   103,   104,
     108,   110,   374,     0,   376,   377,   355,   361,   363,   360,
     373,   356,   463,   396,     0,   425,   405,   414,   502,   138,
     142,    24,     0,     0,     0,     0,   278,   278,   278,   278,
       0,     0,     0,   224,   230,     0,     0,   345,   328,   330,
       0,   217,   319,   320,   318,   233,     0,   313,   105,     0,
     461,   465,   398,     0,   449,   450,   451,     0,     0,     0,
       0,     0,     0,     0,   410,   424,     0,     0,     0,   508,
       0,   147,   142,   142,   142,   142,     0,     0,     0,     0,
     339,   278,   251,   278,   278,     0,   278,   344,   248,   375,
       0,     0,   452,    16,     0,    16,   402,     0,   418,   416,
     415,     0,     0,   419,   421,   422,   423,   413,   503,   497,
     498,   499,   500,   501,   504,   506,   143,   144,   145,   146,
     338,   279,   342,     0,   278,   336,   231,     0,     0,     0,
       0,     0,     0,     0,   331,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   464,
     447,     0,   453,   408,   409,   407,   406,   417,   420,     0,
       0,   278,     0,   346,     0,   341,   340,   278,   278,   278,
     347,   454,   432,   439,   426,   429,   427,     0,   431,     0,
     433,   435,   436,   437,   441,   442,   443,    16,   428,     0,
     462,   343,   232,   337,   278,   278,     0,     0,     0,     0,
     430,   434,   438,   444,   445,   446,   253,   252,     0,     0,
       0,     0,   440,   455,   456,   457,   349,   350,   348,     0,
     458,   459
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   432,    66,   433,   512,   745,   746,   737,
     912,   530,    67,   325,   134,   328,   588,   589,    68,   141,
     142,    69,    16,    17,    18,   102,    70,   273,    71,   279,
     274,    72,   340,    73,   342,   615,    74,    75,   179,   201,
     439,   425,    76,   668,   890,   796,   669,   670,    77,    78,
     434,   202,   284,   539,   540,   293,   547,   548,   258,   721,
     259,   260,   734,    19,    20,    21,   303,    22,    23,    24,
     301,   565,    25,    26,    27,    28,    29,    30,    31,    32,
      33,   126,   319,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    99,   297,    79,   341,    80,   606,   607,   608,
     777,   672,   673,   440,   618,   610,    81,   345,   871,   872,
    1015,   371,   170,   373,   374,   375,   171,   377,   378,  1017,
     351,   172,   352,   360,   173,   174,   175,   874,   176,   404,
     626,   875,   929,   930,   627,   628,   876,    82,    83,    84,
      85,   237,   238,   239,   484,   712,   831,   832,   947,   987,
     713,   907,   956,   714,  1041,   904,   944,   945,   946,  1089,
    1103,  1104,  1105,   824,   980,   941,   825,   758,    43,    44,
      45,    46,    47,    48,    86,    87,    88,    89,   500,  1004,
     960,   908,   837,   492,   493,    90,    91,   265,   266,    49,
      92,    50,    93,    94,    95,   405
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -892
static const yytype_int16 yypact[] =
{
      37,  1537,   196,   161,   412,   273,   148,   521,   412,   223,
     442,   617,   434,   412,   412,   412,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   221,   269,    11,    46,   255,   166,  -892,
     297,   239,   217,   302,   495,  -892,  -892,  -892,  -892,  -892,
     354,   354,  -892,  -892,  -892,   361,  -892,   354,  1382,  -892,
    -892,  -892,   354,  1263,   354,  1075,   354,  1144,   354,  1248,
     354,  1423,  -892,  -892,  1292,  1341,  -892,  -892,  -892,    27,
    -892,   359,   383,  -892,   412,   412,   404,   157,  -892,   539,
     155,   425,  -892,   418,   137,   418,   452,   456,   468,   478,
     482,   511,   513,  -892,  -892,  -892,   509,   533,   545,   564,
     504,  -892,   487,  -892,   -11,    27,    35,  -892,  -892,  -892,
    -892,    75,   279,  -892,   410,  -892,  -892,   320,   157,  -892,
      34,  -892,  -892,  -892,   548,   327,  -892,   472,   474,    -2,
     495,  -892,  -892,  -892,   340,   344,   367,   377,   495,    30,
    -892,  -892,  -892,  -892,  -892,  1009,  -892,  1653,  -892,   393,
     396,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   398,
      27,   566,   612,    35,   242,  -892,   -14,   -14,   665,   157,
    -892,   419,   420,   403,   -76,   678,   242,   492,   512,   -19,
     614,   546,   405,   654,   549,   667,    35,   558,   556,   306,
     563,   551,   382,   560,   544,   242,   541,   552,   543,  -892,
     476,   479,   410,   242,    35,  -892,  -892,   499,  -892,   500,
     502,   718,   330,  -892,   506,   505,  -892,   778,    35,   516,
     -37,    35,    35,   739,   741,   120,  -892,   524,   525,  -892,
     526,   527,   405,  -892,   530,   250,   531,   746,   242,   755,
     242,   754,  -892,   540,   542,   557,   759,   811,  -892,   568,
     569,  -892,  -892,   591,   827,   828,  -892,   829,   831,  -892,
    -892,  -892,   303,   832,  -892,  -892,   580,   834,  -892,   847,
    -892,  1475,  -892,   848,   418,   418,   418,   418,   418,   850,
     855,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   856,
    -892,  -892,  -892,    74,   842,  -892,  -892,  1460,   582,  -892,
    -892,  -892,   495,  -892,    35,   550,  -892,  -892,  -892,  -892,
     583,  1496,   115,  -892,   584,   593,    34,  -892,    34,   495,
      34,    34,   860,  -892,   858,   428,   849,   851,    -2,    -2,
     861,  -892,   495,   495,   495,   495,    10,  -892,  -892,  -892,
     862,  -892,  -892,   852,  -892,    43,    58,  -892,   151,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,   495,   495,   495,   495,
     495,   495,   495,   495,   495,   417,   495,   495,   495,   495,
    -892,  -892,  -892,  -892,  -892,  -892,   410,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  1126,  -892,   495,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,   817,   835,   609,
     611,    35,   857,   680,   242,   405,    35,  -892,  -892,   729,
      35,   839,    35,   726,   843,   725,    35,    35,   242,   845,
     628,   840,   632,   242,   634,   242,   192,   242,  -892,  -892,
     633,  -892,  -892,  -892,   293,  -892,  -892,   898,   637,   639,
    -892,  -892,  -892,   641,  -892,   647,   853,  -892,  -892,  -892,
     648,   649,   650,    35,    35,   651,   652,   671,  -892,  -892,
     337,  -892,     0,  -892,  -892,  -892,   229,  -892,  -892,  -892,
      35,  -892,    35,  -892,   242,  -892,  -892,  -892,    35,  -892,
     405,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   345,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,   347,  -892,  -892,
     949,  -892,  -892,  -892,  -892,   934,   936,  -892,  1126,  -892,
    -892,  -892,   405,  -892,  -892,   960,  -892,  -892,   961,   961,
     961,   961,   961,  -892,  -892,  -892,   699,   701,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   349,  -892,
    -892,   767,   963,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,    97,   703,   707,  -892,
    -892,  -892,   405,    35,  -892,  -892,  -892,   555,  1496,  -892,
    -892,   818,  -892,  -892,  -892,  -892,    47,  -892,   711,  -892,
    -892,  -892,  -892,  -892,   859,   112,   121,   153,  -892,   495,
     708,   966,    63,  -892,  -892,  -892,   979,   990,  -892,  1532,
    1532,  1532,  1662,  1662,  1532,  1532,  1532,  1532,  -892,   730,
    -892,  -892,  -892,   615,   615,  -892,  -892,  -892,   982,  -892,
     732,  -892,  -892,  -892,  1653,    35,    35,  -892,  -892,   737,
     242,   242,   738,   740,   742,    35,   758,    35,   760,   405,
      35,   761,   762,   763,   764,    35,  -892,   410,  -892,   765,
    -892,   781,   782,   783,   784,   809,  -892,  -892,   174,   757,
     773,   405,   813,  -892,   816,   815,  -892,  -892,    84,  -892,
    -892,   830,   821,  -892,  -892,  -892,   836,   837,  -892,  -892,
    -892,    35,   385,   392,   838,    35,   405,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,     0,  -892,  -892,  -892,   591,  -892,
     303,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  1017,  1106,
    1107,  1108,  1110,  -892,  -892,  -892,  1460,  -892,  -892,  -892,
    -892,  1496,   235,  -892,  -892,  -892,  -892,   379,  -892,  -892,
     495,  -892,  -892,   495,   495,   495,   915,  1104,    63,  -892,
    -892,   846,   548,  -892,   495,  -892,   483,  -892,   865,   864,
    -892,   869,   872,  -892,  -892,  -892,   873,  -892,   875,  -892,
     876,   879,  -892,  -892,  -892,  -892,   890,   891,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,    35,  -892,  -892,   410,
    -892,  -892,   854,  -892,  -892,  -892,  -892,  -892,  -892,   853,
    -892,  -892,   892,  1100,  1100,  1100,  1100,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,    19,
    -892,  1099,  -892,  -892,   844,   495,  -892,  -892,  -892,   495,
     495,   893,  1109,  1009,   894,   477,  -892,  -892,  1496,  -892,
     939,   948,   977,  -892,   896,  -892,  1117,  1003,   405,  -892,
    -892,  -892,  -892,    35,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,   201,  -892,    -4,  -892,  -892,   233,   126,  -892,
     337,  -892,   899,   902,   903,   905,   495,   428,   495,  -892,
     195,  1591,   390,  -892,  -892,  1116,    78,  -892,  1653,   889,
     908,  -892,  -892,  -892,  -892,  -892,   895,  -892,  -892,   909,
    -892,  -892,  -892,    18,  -892,  -892,  -892,   205,    35,    35,
      35,   953,   172,    12,  -892,  -892,   910,    35,   304,  -892,
     911,  -892,   337,   337,   337,   337,   585,   913,   640,   912,
    -892,    42,  -892,   495,   495,   553,   477,  -892,  -892,  -892,
    1350,   917,  -892,   242,    35,   242,  -892,   918,  -892,  -892,
    -892,    35,    35,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,   914,   235,   996,  -892,    93,   717,   743,
     863,   929,   930,   933,  -892,   927,    35,   242,    35,    35,
      35,  1024,    35,   212,   150,    24,   980,    35,   947,  -892,
    -892,   937,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   941,
     940,    42,   943,  -892,   959,  -892,  -892,   495,   495,   495,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,    35,  -892,    35,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,   242,  -892,     9,
    -892,  -892,  -892,  -892,  1151,  1151,  1026,  1049,  1058,    -1,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   962,   964,
     965,  -155,  -892,  -892,  -892,  -892,  -892,  -892,  -892,   967,
    -892,  -892
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -892,  -892,  -892,  -135,  -892,  -204,  -206,  -259,  -552,  -892,
    -300,  -892,  -892,  -892,  -892,  -892,  -892,   461,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  1139,  -892,  -892,  -892,  -892,
    -892,  -892,  -228,  -892,  -892,  -892,  -892,  -892,  1308,  1004,
    1045,  -892,  -892,  -892,  -892,  -892,   450,  -483,  -892,  -892,
    -892,  -892,   -40,  -892,   503,   -43,  -892,   498,  -827,   415,
    -482,  -892,  -431,  -892,  -892,  -892,   -65,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,   694,   971,  -892,  -892,  -892,  -892,  -594,   491,
    -892,   928,   710,   969,  -892,   653,  -892,  -892,  -891,  -892,
     222,  -892,  -162,   484,  -637,  -892,  -161,   638,  -892,  -892,
    -892,  -892,   268,   314,  -892,  -892,  -747,  -892,   -56,   411,
     -64,  -892,  -892,   310,   508,   372,  -717,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,    -8,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,  -892,
    -892,  -892,  -892,  -892,  -892,  -785
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -335
static const yytype_int16 yytable[] =
{
     177,   333,   450,   513,   480,   790,   459,   372,   376,   718,
     755,   358,   457,   458,   722,  1101,   406,   407,   408,   409,
     410,   474,   330,   776,   435,   873,   331,   326,   735,   481,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   916,
     497,     1,   564,   367,   368,   369,   154,   346,   330,   309,
     310,   347,   331,   406,   407,   408,   409,   410,   427,   859,
     281,   348,   436,   437,   521,   282,   523,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   367,   368,   369,   789,
     955,   463,   137,   644,   645,  1109,   860,   330,   926,   994,
     576,   331,   453,   334,   353,   329,   361,   135,   974,   482,
     138,  1074,   975,   136,   366,   344,   367,   368,   369,   789,
     447,   448,   861,   495,   769,   139,   501,   502,   406,   407,
     408,   409,   410,  1050,  1110,   873,   335,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     423,   103,   438,  1040,   302,   924,   443,   140,   298,   406,
     407,   408,   409,   410,    52,   862,   863,   864,   865,   866,
     867,   868,   969,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   454,   869,  1013,   330,   870,   330,   577,   331,
     290,   331,    53,  1096,  1097,   291,    51,    54,   667,   592,
      55,   406,   407,   408,   409,   410,   428,   429,   430,   431,
     304,    56,   611,   612,   613,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   873,   330,   108,    57,    58,   331,
      59,   498,   499,   770,   144,   147,  1052,    60,   130,   568,
     569,   570,   571,   572,   889,   457,   458,   738,   995,   683,
     682,   996,   859,   305,  1016,   330,    61,  1093,  1094,   331,
    1075,   981,   992,  1076,   694,   299,    62,   873,   591,   699,
     327,   701,   143,   705,   428,   429,   430,   431,   942,   860,
     736,  1102,   359,    63,   931,   621,   332,   131,   638,   505,
     353,   100,   353,   639,   353,   353,   917,   982,   634,   635,
     636,   637,  1069,   148,   873,   861,   132,   370,   283,   957,
     739,   349,   332,   247,   145,   983,   679,   133,   350,   149,
     742,   684,   101,  1014,   744,   686,   642,   688,    64,   643,
     780,   692,   693,   249,  1016,   146,   938,   873,   873,   646,
     370,   902,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   332,   663,   664,   665,   666,   744,   722,   862,   863,
     864,   865,   866,   867,   868,   836,   707,   797,   726,   727,
     370,   178,   702,  1071,   674,  1053,   869,   100,   515,   870,
    1054,   545,   958,  1072,  1073,   740,   286,   741,   306,   307,
     308,   506,   507,   743,   614,   783,   406,   407,   408,   409,
     410,   826,   703,   704,   784,   731,   773,   289,   959,   546,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   181,
     948,   457,   458,   337,   182,   338,   339,   516,   300,    96,
      97,   732,   984,   183,   647,   302,   785,   648,   292,   150,
      65,   151,   152,   153,   154,   155,   156,   123,   985,   332,
      98,   332,   830,   157,   158,   311,   159,   184,   160,   312,
     517,   949,   950,   951,   733,   952,   843,   124,   844,   817,
     953,   313,   125,   845,   970,   846,   801,   802,   774,   961,
     372,   314,   940,   810,   797,   315,   376,   986,   150,   332,
     151,   152,   153,   154,   155,   156,   466,   467,   161,   457,
     458,   888,   157,   158,   827,   159,   150,   160,   151,   152,
     153,   154,   155,   156,   316,   954,   317,  -227,   708,   332,
     157,   158,   318,   159,   323,   160,   518,   999,   109,   110,
     849,  1006,  1007,  1008,  1009,   709,   320,   710,    96,    97,
     798,   799,   324,   711,   913,   914,   915,   161,   321,   658,
     806,   111,   808,   112,   113,   811,   294,   295,   336,    98,
     816,   759,   760,   761,   762,   161,   659,   322,  1000,  1001,
    1002,  1003,   660,   162,   163,   786,   354,   296,   185,   661,
     662,   470,   471,   424,   164,   165,   166,   488,   489,   167,
     744,   406,   407,   408,   409,   410,   842,   294,   295,   343,
     848,   905,   593,   594,   355,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   619,   186,   620,   362,   622,   623,
     187,   363,   162,   163,   104,   105,   372,   747,   748,   749,
     750,   765,   766,   164,   165,   166,   188,   356,   167,   357,
     162,   163,   418,   419,   364,   943,   406,   407,   408,   409,
     410,   164,   165,   166,   365,   533,   167,   877,   878,   114,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   534,
     535,   972,   631,   632,   420,   536,   537,   421,   538,   422,
     426,   116,   744,   442,   446,   596,   597,   598,   599,   600,
     601,   903,   602,   603,   604,   605,   449,   451,   444,   445,
     452,   106,   107,   117,   118,   168,  -334,   127,   128,   129,
    1020,  1021,   455,   169,  1022,   460,   456,   115,  1023,   880,
     881,   882,   461,   406,   407,   408,   409,   410,   462,   464,
     887,   119,   120,   121,   122,   465,   469,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   468,   473,   475,   406,
     407,   408,   409,   410,   168,   478,  -329,   477,   939,   472,
     479,   476,   169,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   168,   406,   407,   408,   409,   410,   483,  1043,
     169,  1045,   485,   486,   487,   490,   491,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   494,   496,   287,   288,
     503,   920,   504,   508,   509,   921,   922,   510,   511,   514,
     519,   928,   520,   988,   989,   990,   522,   993,   524,   525,
     528,   526,   998,  1063,   406,   407,   408,   409,   410,   529,
     541,   542,   543,   775,   544,   549,   527,   551,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   531,   532,  1044,
     552,   567,   966,   573,   968,   372,  1047,  1048,   574,   575,
     578,   590,   595,   616,  1010,   406,   407,   408,   409,   410,
     617,   625,   624,  1092,   629,   640,   641,   630,   675,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   677,   633,
     678,  1062,   681,  1064,  1065,  1066,   676,  1068,  1070,   685,
     687,   680,  1078,   689,   690,   691,   695,   696,   697,  1018,
    1019,   698,   928,   700,   706,   715,   716,   379,   717,  1012,
     719,   406,   407,   408,   409,   410,   720,   723,   724,   725,
     728,   729,  1090,   247,  1091,   411,   412,   413,   414,   415,
     416,   417,   418,   419,  1095,   406,   407,   408,   409,   410,
     730,   752,   751,   753,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   756,   763,   757,
     764,   768,   771,   406,   407,   408,   409,   410,   772,   781,
     788,   787,   791,  1086,  1087,  1088,  1055,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   792,   794,   795,   406,
     407,   408,   409,   410,   379,   797,   800,   803,   829,   804,
     852,   805,  1056,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   406,   407,   408,   409,   410,   807,   828,   809,
     812,   813,   814,   815,   818,   767,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   406,   407,   408,   409,   410,
     819,   820,   821,   822,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   230,   823,   236,
     380,   244,   833,   257,   835,   264,   779,   834,   275,   280,
     839,   388,   389,   390,   391,   392,   393,   394,   395,   853,
     854,   855,   838,   856,   190,   840,   841,   884,   911,   918,
     847,   919,  -228,  -228,  -228,  -228,   859,   396,   397,   886,
     936,   398,   399,   400,   401,   906,   973,   782,   991,  1051,
    1057,   191,   192,   671,   892,   193,   194,   893,   894,   196,
     197,   895,   896,   860,   897,   898,   381,   382,   899,   383,
     384,   385,   386,   387,  -227,  -227,  -227,  -227,   859,   900,
     901,   910,   976,   927,   935,   923,   198,   978,   962,   861,
     199,   963,   964,   190,   965,   402,   403,   977,   979,   997,
    1005,  1011,  1049,   883,  1079,   860,  1042,  1046,   388,   389,
     390,   391,   392,   393,   394,   395,  1058,  1059,  1061,  1067,
     191,   192,  1060,  1077,   193,   194,  1080,   932,   196,   197,
    1081,   861,  1082,  1084,   396,   397,   933,   857,   398,   399,
     400,   401,   862,   863,   864,   865,   866,   867,   868,  1085,
     285,  1106,   441,  1107,  1108,   198,  1111,   891,   851,   199,
     869,   850,  -228,   870,   909,   934,   596,   597,   598,   599,
     600,   601,   858,   602,   603,   604,   605,   550,   754,   609,
     566,   778,   885,  1083,   862,   863,   864,   865,   866,   867,
     868,   937,   402,   403,   925,   793,  1024,   190,   879,   967,
       0,     0,   869,   232,  -227,   870,     0,     0,     0,   233,
       0,   234,   190,     0,  1098,     0,     0,   204,     0,     0,
       0,     0,     0,     0,   191,   192,     0,     0,   193,   194,
       0,   246,   196,   197,     0,     0,     0,  1099,   247,   191,
     192,   190,     0,   193,   194,     0,  1100,   196,   197,     0,
       0,     0,     0,   205,     0,   206,     0,   248,   249,   198,
     267,   268,   269,   199,   270,   271,     0,   235,   191,   192,
       0,     0,   193,   194,   198,     0,   196,   197,   199,     0,
       0,     0,     0,     0,   207,     0,     0,     0,     0,   180,
     190,     0,   208,   209,     0,   189,  -228,     0,     0,     0,
     203,  -228,   231,   198,   240,     0,   245,   199,   261,   241,
     242,   276,     0,     0,     0,     0,     0,   191,   192,     0,
       0,   193,   194,     0,   210,   196,   197,     0,     0,     0,
       0,   190,     0,     0,     0,     0,   243,     0,  -227,   277,
     247,   211,   212,  -227,   213,   214,     0,   215,   216,   217,
       0,   218,   198,     0,   219,   220,   199,   221,   191,   192,
     249,     0,   193,   194,     0,   195,   196,   197,     0,     0,
     222,   223,   190,     0,     0,   224,  1025,   225,     0,   226,
       0,   227,     0,     0,     0,     0,   228,     0,   553,     0,
       0,     0,     0,   198,     0,   250,     0,   199,     0,   191,
     192,   457,   458,   193,   194,     0,     0,   196,   197,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   251,   252,
     253,   254,     0,   554,     0,     0,     0,     0,   255,     0,
       0,     0,     0,     0,   198,     0,     0,     0,   199,     0,
     256,     0,     0,     0,   262,     0,     0,  1026,  -335,  -335,
    -335,   555,     0,     0,   556,   229,     0,     0,     0,     0,
     557,   558,  -335,  -335,  -335,  -335,  -335,   416,   417,   418,
     419,     0,     0,   559,   560,   561,   562,     0,   563,     0,
       0,     0,     0,     0,   272,  1027,     4,  1028,  1029,  1030,
    1031,  1032,  1033,     0,     0,  1034,     0,  1035,  1036,     0,
       0,  1037,     0,     5,     6,     0,  1038,   406,   407,   408,
     409,   410,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,     0,     0,   278,     0,     0,   596,   597,   598,   599,
     600,   601,  1039,   602,   603,   604,   605,     0,     0,     7,
       0,   438,     8,     0,     9,    10,     0,     0,     0,     0,
      11,     0,     0,     0,     0,    12,    13,    14,    15,   406,
     407,   408,   409,   410,   200,     0,     0,     0,   406,   407,
     408,     0,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   263,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   971
};

static const yytype_int16 yycheck[] =
{
      64,   136,   206,   262,   232,   642,   212,   169,   169,   492,
     562,    13,    16,    17,   496,    16,     6,     7,     8,     9,
      10,   225,    13,   617,    38,   772,    17,    38,    28,   233,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    20,
      77,     4,   301,    13,    14,    15,    16,    13,    13,   114,
     115,    17,    17,     6,     7,     8,     9,    10,   193,    17,
      33,    27,    76,    77,   268,    38,   270,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    13,    14,    15,    16,
     907,   216,    36,    25,    26,   240,    44,    13,   873,    77,
      16,    17,   111,    18,   150,   135,   160,    86,    20,   234,
      54,    77,    24,    92,   168,   148,    13,    14,    15,    16,
     186,   187,    70,   248,    17,    69,   251,   252,     6,     7,
       8,     9,    10,  1014,   279,   872,    51,     6,     7,     8,
       9,    10,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     190,     3,   166,   980,    17,   872,   199,   111,     3,     6,
       7,     8,     9,    10,     3,   123,   124,   125,   126,   127,
     128,   129,   919,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   201,   141,   969,    13,   144,    13,   323,    17,
      33,    17,    31,  1084,  1085,    38,     0,    36,   426,   334,
      39,     6,     7,     8,     9,    10,    32,    33,    34,    35,
      73,    50,    97,    98,    99,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   971,    13,     3,    66,    67,    17,
      69,   268,   269,   136,    68,    18,   143,    76,    17,   304,
     305,   306,   307,   308,   796,    16,    17,    18,   236,   455,
     454,   239,    17,   116,   971,    13,    95,   248,   249,    17,
     236,   243,    90,   239,   468,   110,   105,  1014,   332,   473,
     281,   475,    17,   477,    32,    33,    34,    35,   282,    44,
     280,   282,   284,   122,   878,   349,   277,    18,   278,   169,
     346,    18,   348,   283,   350,   351,   277,   279,   362,   363,
     364,   365,    90,    86,  1051,    70,    37,   277,   281,   183,
     516,   277,   277,    80,    17,   110,   451,    48,   284,    17,
     524,   456,    49,   281,   530,   460,   283,   462,   167,   286,
     283,   466,   467,   100,  1051,    96,   888,  1084,  1085,   281,
     277,   824,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   277,   416,   417,   418,   419,   562,   839,   123,   124,
     125,   126,   127,   128,   129,   281,    73,   283,   503,   504,
     277,    17,   180,   223,   438,   282,   141,    18,   128,   144,
    1017,    78,   256,   233,   234,   520,     3,   522,   251,   252,
     253,   271,   272,   528,   279,   283,     6,     7,     8,     9,
      10,   227,   210,   211,   283,    68,   612,     3,   282,   106,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    58,
     187,    16,    17,    13,    63,    15,    16,   177,     3,    17,
      18,    94,   227,    72,   283,    17,   283,   286,   281,    11,
     279,    13,    14,    15,    16,    17,    18,    13,   243,   277,
      38,   277,   711,    25,    26,     3,    28,    96,    30,     3,
     210,   228,   229,   230,   127,   232,    81,    33,    83,   697,
     237,     3,    38,    81,   279,    83,   680,   681,   613,   910,
     642,     3,   281,   689,   283,     3,   647,   282,    11,   277,
      13,    14,    15,    16,    17,    18,   190,   191,    70,    16,
      17,    18,    25,    26,   708,    28,    11,    30,    13,    14,
      15,    16,    17,    18,     3,   282,     3,   282,   225,   277,
      25,    26,    13,    28,    20,    30,   276,   223,    86,    87,
     736,   962,   963,   964,   965,   242,     3,   244,    17,    18,
     675,   676,    55,   250,   844,   845,   846,    70,     3,   132,
     685,   109,   687,   111,   112,   690,    17,    18,   279,    38,
     695,   569,   570,   571,   572,    70,   149,     3,   264,   265,
     266,   267,   155,   145,   146,   639,    28,    38,   217,   162,
     163,   199,   200,    17,   156,   157,   158,   257,   258,   161,
     796,     6,     7,     8,     9,    10,   731,    17,    18,   279,
     735,   829,    52,    53,   277,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   346,   254,   348,   277,   350,   351,
     259,   277,   145,   146,   103,   104,   788,   282,   283,   282,
     283,   282,   283,   156,   157,   158,   275,   165,   161,   165,
     145,   146,    27,    28,   277,   904,     6,     7,     8,     9,
      10,   156,   157,   158,   277,    64,   161,   278,   279,   217,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    78,
      79,   281,   358,   359,   281,    84,    85,   281,    87,   281,
      68,    64,   888,    18,   281,   130,   131,   132,   133,   134,
     135,   826,   137,   138,   139,   140,    18,   205,   279,   279,
     188,     7,     8,    86,    87,   277,   278,    13,    14,    15,
     157,   158,    98,   285,   161,    61,   170,   275,   165,   783,
     784,   785,   173,     6,     7,     8,     9,    10,    61,   171,
     794,   114,   115,   116,   117,   179,   185,    20,    21,    22,
      23,    24,    25,    26,    27,    28,   183,   203,   207,     6,
       7,     8,     9,    10,   277,   279,   279,   214,   893,   199,
     281,   209,   285,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   277,     6,     7,     8,     9,    10,   279,   983,
     285,   985,   282,   281,    66,   279,   281,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    18,   281,   104,   105,
      61,   865,    61,   279,   279,   869,   870,   281,   281,   279,
     279,   875,    66,   948,   949,   950,    61,   952,    64,   279,
      61,   279,   957,  1027,     6,     7,     8,     9,    10,    18,
       3,     3,     3,   278,     3,     3,   279,     3,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   279,   279,   984,
       3,     3,   916,     3,   918,  1017,   991,   992,     3,     3,
      18,   279,   279,   279,   279,     6,     7,     8,     9,    10,
     277,    13,    12,  1077,    25,    13,    24,    26,    61,    20,
      21,    22,    23,    24,    25,    26,    27,    28,   279,    28,
     279,  1026,   212,  1028,  1029,  1030,    61,  1032,  1033,   170,
      61,    44,  1037,   177,    61,   180,    61,   279,    68,   973,
     974,   279,   976,   279,   281,    17,   279,     5,   279,   279,
     279,     6,     7,     8,     9,    10,   279,   279,   279,   279,
     279,   279,  1067,    80,  1069,    20,    21,    22,    23,    24,
      25,    26,    27,    28,  1079,     6,     7,     8,     9,    10,
     279,    17,     3,    17,     6,     7,     8,     9,    10,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    17,   279,    18,
     279,    18,   279,     6,     7,     8,     9,    10,   281,   278,
      24,   283,    13,  1057,  1058,  1059,   279,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    16,   277,    26,     6,
       7,     8,     9,    10,     5,   283,   279,   279,   245,   279,
       3,   279,   279,    20,    21,    22,    23,    24,    25,    26,
      27,    28,     6,     7,     8,     9,    10,   279,   281,   279,
     279,   279,   279,   279,   279,   278,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     6,     7,     8,     9,    10,
     279,   279,   279,   279,     6,     7,     8,     9,    10,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    83,   279,    85,
      81,    87,   279,    89,   279,    91,   278,   281,    94,    95,
     279,   189,   190,   191,   192,   193,   194,   195,   196,     3,
       3,     3,   282,     3,    39,   279,   279,    13,    18,    20,
     282,   277,    13,    14,    15,    16,    17,   215,   216,   283,
      13,   219,   220,   221,   222,   281,    20,   278,   185,   143,
     277,    66,    67,    17,   279,    70,    71,   283,   279,    74,
      75,   279,   279,    44,   279,   279,   147,   148,   279,   150,
     151,   152,   153,   154,    13,    14,    15,    16,    17,   279,
     279,   279,   283,   279,   278,   282,   101,   282,   279,    70,
     105,   279,   279,    39,   279,   273,   274,   279,   279,   279,
     279,   278,   278,   278,   247,    44,   279,   279,   189,   190,
     191,   192,   193,   194,   195,   196,   277,   277,   281,   185,
      66,    67,   279,   233,    70,    71,   279,   278,    74,    75,
     279,    70,   282,   280,   215,   216,   278,   766,   219,   220,
     221,   222,   123,   124,   125,   126,   127,   128,   129,   280,
     101,   279,   197,   279,   279,   101,   279,   797,   750,   105,
     141,   748,   143,   144,   839,   278,   130,   131,   132,   133,
     134,   135,   771,   137,   138,   139,   140,   296,   558,   341,
     301,   618,   788,  1051,   123,   124,   125,   126,   127,   128,
     129,   278,   273,   274,   873,   647,   976,    39,   780,   917,
      -1,    -1,   141,   218,   143,   144,    -1,    -1,    -1,   224,
      -1,   226,    39,    -1,   278,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    70,    71,
      -1,    73,    74,    75,    -1,    -1,    -1,   278,    80,    66,
      67,    39,    -1,    70,    71,    -1,   278,    74,    75,    -1,
      -1,    -1,    -1,    80,    -1,    82,    -1,    99,   100,   101,
      58,    59,    60,   105,    62,    63,    -1,   282,    66,    67,
      -1,    -1,    70,    71,   101,    -1,    74,    75,   105,    -1,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,    71,
      39,    -1,   119,   120,    -1,    77,   277,    -1,    -1,    -1,
      82,   282,    84,   101,    86,    -1,    88,   105,    90,   255,
     256,    60,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,    70,    71,    -1,   151,    74,    75,    -1,    -1,    -1,
      -1,    39,    -1,    -1,    -1,    -1,   282,    -1,   277,    88,
      80,   168,   169,   282,   171,   172,    -1,   174,   175,   176,
      -1,   178,   101,    -1,   181,   182,   105,   184,    66,    67,
     100,    -1,    70,    71,    -1,    73,    74,    75,    -1,    -1,
     197,   198,    39,    -1,    -1,   202,   116,   204,    -1,   206,
      -1,   208,    -1,    -1,    -1,    -1,   213,    -1,     3,    -1,
      -1,    -1,    -1,   101,    -1,   237,    -1,   105,    -1,    66,
      67,    16,    17,    70,    71,    -1,    -1,    74,    75,    39,
      40,    41,    42,    43,    44,    45,    46,    47,   260,   261,
     262,   263,    -1,    38,    -1,    -1,    -1,    -1,   270,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,    -1,
     282,    -1,    -1,    -1,   111,    -1,    -1,   187,     6,     7,
       8,    66,    -1,    -1,    69,   282,    -1,    -1,    -1,    -1,
      75,    76,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    -1,    -1,    -1,   282,   225,    39,   227,   228,   229,
     230,   231,   232,    -1,    -1,   235,    -1,   237,   238,    -1,
      -1,   241,    -1,    56,    57,    -1,   246,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    -1,    -1,   282,    -1,    -1,   130,   131,   132,   133,
     134,   135,   282,   137,   138,   139,   140,    -1,    -1,   102,
      -1,   166,   105,    -1,   107,   108,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,   118,   119,   120,   121,     6,
       7,     8,     9,    10,   282,    -1,    -1,    -1,     6,     7,
       8,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   142
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   288,   289,    39,    56,    57,   102,   105,   107,
     108,   113,   118,   119,   120,   121,   309,   310,   311,   350,
     351,   352,   354,   355,   356,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   455,   456,   457,   458,   459,   460,   476,
     478,     0,     3,    31,    36,    39,    50,    66,    67,    69,
      76,    95,   105,   122,   167,   279,   291,   299,   305,   308,
     313,   315,   318,   320,   323,   324,   329,   335,   336,   381,
     383,   393,   424,   425,   426,   427,   461,   462,   463,   464,
     472,   473,   477,   479,   480,   481,    17,    18,    38,   379,
      18,    49,   312,     3,   103,   104,   379,   379,     3,    86,
      87,   109,   111,   112,   217,   275,    64,    86,    87,   114,
     115,   116,   117,    13,    33,    38,   368,   379,   379,   379,
      17,    18,    37,    48,   301,    86,    92,    36,    54,    69,
     111,   306,   307,    17,    68,    17,    96,    18,    86,    17,
      11,    13,    14,    15,    16,    17,    18,    25,    26,    28,
      30,    70,   145,   146,   156,   157,   158,   161,   277,   285,
     399,   403,   408,   411,   412,   413,   415,   417,    17,   325,
     325,    58,    63,    72,    96,   217,   254,   259,   275,   325,
      39,    66,    67,    70,    71,    73,    74,    75,   101,   105,
     282,   326,   338,   325,    44,    80,    82,   111,   119,   120,
     151,   168,   169,   171,   172,   174,   175,   176,   178,   181,
     182,   184,   197,   198,   202,   204,   206,   208,   213,   282,
     326,   325,   218,   224,   226,   282,   326,   428,   429,   430,
     325,   255,   256,   282,   326,   325,    73,    80,    99,   100,
     237,   260,   261,   262,   263,   270,   282,   326,   345,   347,
     348,   325,   111,   282,   326,   474,   475,    58,    59,    60,
      62,    63,   282,   314,   317,   326,    60,    88,   282,   316,
     326,    33,    38,   281,   339,   312,     3,   379,   379,     3,
      33,    38,   281,   342,    17,    18,    38,   380,     3,   110,
       3,   357,    17,   353,    73,   116,   251,   252,   253,   353,
     353,     3,     3,     3,     3,     3,     3,     3,    13,   369,
       3,     3,     3,    20,    55,   300,    38,   281,   302,   339,
      13,    17,   277,   290,    18,    51,   279,    13,    15,    16,
     319,   382,   321,   279,   342,   394,    13,    17,    27,   277,
     284,   407,   409,   415,    28,   277,   165,   165,    13,   284,
     410,   417,   277,   277,   277,   277,   417,    13,    14,    15,
     277,   398,   399,   400,   401,   402,   403,   404,   405,     5,
      81,   147,   148,   150,   151,   152,   153,   154,   189,   190,
     191,   192,   193,   194,   195,   196,   215,   216,   219,   220,
     221,   222,   273,   274,   416,   482,     6,     7,     8,     9,
      10,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     281,   281,   281,   339,    17,   328,    68,   290,    32,    33,
      34,    35,   290,   292,   337,    38,    76,    77,   166,   327,
     390,   327,    18,   342,   279,   279,   281,   186,   187,    18,
     292,   205,   188,   111,   201,    98,   170,    16,    17,   293,
      61,   173,    61,   290,   171,   179,   190,   191,   183,   185,
     199,   200,   199,   203,   292,   207,   209,   214,   279,   281,
     319,   292,   290,   279,   431,   282,   281,    66,   257,   258,
     279,   281,   470,   471,    18,   290,   281,    77,   268,   269,
     465,   290,   290,    61,    61,   169,   271,   272,   279,   279,
     281,   281,   293,   294,   279,   128,   177,   210,   276,   279,
      66,   292,    61,   292,    64,   279,   279,   279,    61,    18,
     298,   279,   279,    64,    78,    79,    84,    85,    87,   340,
     341,     3,     3,     3,     3,    78,   106,   343,   344,     3,
     380,     3,     3,     3,    38,    66,    69,    75,    76,    88,
      89,    90,    91,    93,   294,   358,   390,     3,   353,   353,
     353,   353,   353,     3,     3,     3,    16,   290,    18,    39,
      40,    41,    42,    43,    44,    45,    46,    47,   303,   304,
     279,   417,   290,    52,    53,   279,   130,   131,   132,   133,
     134,   135,   137,   138,   139,   140,   384,   385,   386,   388,
     392,    97,    98,    99,   279,   322,   279,   277,   391,   409,
     409,   417,   409,   409,    12,    13,   417,   421,   422,    25,
      26,   410,   410,    28,   417,   417,   417,   417,   278,   283,
      13,    24,   283,   286,    25,    26,   281,   283,   286,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   132,   149,
     155,   162,   163,   417,   417,   417,   417,   319,   330,   333,
     334,    17,   388,   389,   417,    61,    61,   279,   279,   290,
      44,   212,   292,   293,   290,   170,   290,    61,   290,   177,
      61,   180,   290,   290,   292,    61,   279,    68,   279,   292,
     279,   292,   180,   210,   211,   292,   281,    73,   225,   242,
     244,   250,   432,   437,   440,    17,   279,   279,   334,   279,
     279,   346,   347,   279,   279,   279,   290,   290,   279,   279,
     279,    68,    94,   127,   349,    28,   280,   296,    18,   293,
     290,   290,   292,   290,   293,   294,   295,   282,   283,   282,
     283,     3,    17,    17,   389,   295,    17,    18,   454,   454,
     454,   454,   454,   279,   279,   282,   283,   278,    18,    17,
     136,   279,   281,   293,   290,   278,   385,   387,   392,   278,
     283,   278,   278,   283,   283,   283,   417,   283,    24,    16,
     401,    13,    16,   404,   277,    26,   332,   283,   290,   290,
     279,   292,   292,   279,   279,   279,   290,   279,   290,   279,
     293,   290,   279,   279,   279,   279,   290,   319,   279,   279,
     279,   279,   279,   279,   450,   453,   227,   292,   281,   245,
     294,   433,   434,   279,   281,   279,   281,   469,   282,   279,
     279,   279,   290,    81,    83,    81,    83,   282,   290,   293,
     341,   344,     3,     3,     3,     3,     3,   304,   386,    17,
      44,    70,   123,   124,   125,   126,   127,   128,   129,   141,
     144,   395,   396,   413,   414,   418,   423,   278,   279,   421,
     417,   417,   417,   278,    13,   400,   283,   417,    18,   295,
     331,   333,   279,   283,   279,   279,   279,   279,   279,   279,
     279,   279,   334,   290,   442,   319,   281,   438,   468,   346,
     279,    18,   297,   297,   297,   297,    20,   277,    20,   277,
     417,   417,   417,   282,   423,   416,   482,   279,   417,   419,
     420,   385,   278,   278,   278,   278,    13,   278,   295,   290,
     281,   452,   282,   294,   443,   444,   445,   435,   187,   228,
     229,   230,   232,   237,   282,   345,   439,   183,   256,   282,
     467,   349,   279,   279,   279,   279,   417,   422,   417,   413,
     279,   142,   281,    20,    20,    24,   283,   279,   282,   279,
     451,   243,   279,   110,   227,   243,   282,   436,   290,   290,
     290,   185,    90,   290,    77,   236,   239,   279,   290,   223,
     264,   265,   266,   267,   466,   279,   349,   349,   349,   349,
     279,   278,   279,   482,   281,   397,   423,   406,   417,   417,
     157,   158,   161,   165,   420,   116,   187,   225,   227,   228,
     229,   230,   231,   232,   235,   237,   238,   241,   246,   282,
     345,   441,   279,   292,   290,   292,   279,   290,   290,   278,
     395,   143,   143,   282,   401,   279,   279,   277,   277,   277,
     279,   281,   290,   292,   290,   290,   290,   185,   290,    90,
     290,   223,   233,   234,    77,   236,   239,   233,   290,   247,
     279,   279,   282,   397,   280,   280,   417,   417,   417,   446,
     290,   290,   292,   248,   249,   290,   395,   395,   278,   278,
     278,    16,   282,   447,   448,   449,   279,   279,   279,   240,
     279,   279
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 312 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 313 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 326 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 327 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 331 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 335 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 344 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 345 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 346 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 347 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 348 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 349 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 356 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 363 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 371 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 375 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 379 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 386 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 394 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 395 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 401 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 410 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 411 "cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 415 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 420 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 421 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 425 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 426 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 430 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 431 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 435 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 436 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 437 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 438 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 439 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 440 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 441 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 442 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 443 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 449 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 450 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 459 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 460 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 461 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 462 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 465 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 466 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 467 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 468 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 480 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 483 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 486 "cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 489 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 498 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 514 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 515 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 519 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 526 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 532 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 545 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 549 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 562 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 574 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 580 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 582 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 601 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 602 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 603 "cf-parse.y"
    { new_config->listen_bgp_flags |= SKF_V6ONLY; ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 610 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 622 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 628 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 636 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 640 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 641 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 642 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 643 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 644 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 645 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 646 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 647 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 651 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 653 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 654 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 658 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 666 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 667 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 675 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 683 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 684 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 685 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 689 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 690 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 707 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 722 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 737 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 739 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 744 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 748 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 749 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 751 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 752 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 753 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 761 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 766 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 770 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 771 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 792 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 810 "cf-parse.y"
    { ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 811 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 812 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 813 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 814 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 815 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 824 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 827 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 830 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 834 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 838 "cf-parse.y"
    { if_show(); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 841 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 844 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 847 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 853 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 859 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 866 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 871 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 876 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 881 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 885 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 889 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 899 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 907 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 911 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 918 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 919 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 923 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 927 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 929 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 931 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 933 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 935 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 937 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 939 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 941 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 947 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 948 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 953 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 954 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 961 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 963 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 965 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 967 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 969 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 971 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 975 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 979 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 982 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 985 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 986 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 987 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 991 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 992 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 993 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1000 "cf-parse.y"
    { cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1000 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s) = cf_define_symbol((yyvsp[(2) - (4)].s), SYM_FILTER, (yyvsp[(4) - (4)].f));
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1009 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1013 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1014 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1015 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1016 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1017 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1020 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1021 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1022 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1023 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1043 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1054 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1055 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1062 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1063 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1070 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1079 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1087 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1111 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1112 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1116 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1129 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1132 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1145 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1146 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1150 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1154 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1157 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i) = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1173 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1177 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1179 "cf-parse.y"
    { (yyval.v).type = T_PAIR; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1180 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1181 "cf-parse.y"
    {  (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1185 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1190 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1198 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1199 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1203 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1210 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1211 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1212 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1213 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1220 "cf-parse.y"
    { (yyval.trie) = f_new_trie(); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1221 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1224 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1225 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(2) - (4)].e);
     (yyval.e)->data = (yyvsp[(4) - (4)].x);
     (yyval.e)->left = (yyvsp[(1) - (4)].e);
   ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1230 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(4) - (4)].x);
     (yyval.e)->left = (yyvsp[(1) - (4)].e);
   ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1242 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1243 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1247 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1248 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1252 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1253 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1255 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1256 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1261 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1262 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1266 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1279 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1280 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1281 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1282 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1283 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1284 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1285 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1286 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1288 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1289 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1303 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1326 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1360 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1362 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1363 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1364 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1365 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1366 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1367 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1368 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1372 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1373 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1374 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1375 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1378 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1379 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1380 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1381 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1382 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1383 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1389 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1390 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1391 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1393 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1395 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1397 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1399 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1400 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1401 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1402 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1403 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1413 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1414 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1415 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1416 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1417 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1422 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1445 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1446 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1447 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1448 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1450 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1454 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1457 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1458 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1459 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1468 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1475 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1484 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1485 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1489 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1505 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1514 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1520 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1525 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1532 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1537 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1544 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1545 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1554 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1555 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1556 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1557 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1563 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1586 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1587 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1593 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1594 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1595 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1596 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1597 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1598 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1599 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1600 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (6)].i); BGP_CFG->multihop_via = (yyvsp[(5) - (6)].a); ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1601 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1602 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1603 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1604 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1605 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1606 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1607 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1608 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1609 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1610 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1611 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1612 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1613 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1614 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1615 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1616 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1617 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1618 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1619 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1620 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1621 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1631 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1647 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1648 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i) ; if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1652 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (3)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->vlink_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1673 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1674 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1687 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 1701 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1702 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1703 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1707 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 1717 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1718 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 1719 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 1720 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1721 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1722 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 1723 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 1724 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1725 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1730 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1751 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1752 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1753 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 1754 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1755 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1756 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 1757 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 1758 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1759 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1760 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1761 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 1762 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1763 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 1764 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1766 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 1767 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1768 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 1769 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1770 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1771 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) cf_error("Buffer size is too small") ; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1785 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1794 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1813 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 1822 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1832 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->strictnbma = 0;
  OSPF_PATT->stub = 0;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 1865 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 1875 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 1878 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 1881 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 1884 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 1887 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1); ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1890 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 1895 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1905 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 1910 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 1911 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 1917 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 1927 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 1928 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 1929 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 1930 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 1931 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 1933 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 1934 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 1950 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 1951 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 1955 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 1956 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 1970 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 1986 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 1998 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&((struct static_config *) this_proto)->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 2007 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 2011 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&((struct static_config *) this_proto)->iface_routes, &this_srt->n);
   ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 2017 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 2018 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 2019 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 2023 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 2031 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 2031 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 2037 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 2039 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 6792 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 2046 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


